<div class="signup">
  <h1 class="signup__title">Sign-up</h1>

  <form [formGroup]="form" (ngSubmit)="onSubmit()" data-testid="form">

    <div class="field">
      <label>
        <div class="field__name">First name</div>
        <input class="field__control" type="text" formControlName="firstName" data-testid="firstName" />
      </label>

      <app-control-errors controlName="firstName">
        <ng-template let-errors>
          <ng-container *ngIf="errors.required">
            First name must be given.
          </ng-container>
        </ng-template>
      </app-control-errors>
    </div>

    <div class="field">
      <label>
        <div class="field__name">Last name</div>
        <input class="field__control" type="text" formControlName="lastName" data-testid="lastName" />
      </label>

      <div class="field__info">
        <app-control-errors controlName="lastName">
          <ng-template let-errors>
            <ng-container *ngIf="errors.required">
              Last name must be given.
            </ng-container>
          </ng-template>
        </app-control-errors>
      </div>
    </div>

    <div class="field">
      <label>
        <div class="field__name">Email</div>
        <input class="field__control" type="text" formControlName="email" data-testid="email" />
      </label>

      <div class="field__info">
        <app-control-errors controlName="email">
          <ng-template let-errors>
            <ng-container *ngIf="errors.required">
              Email must be given.
            </ng-container>
            <ng-container *ngIf="errors.email">
              Please provide a valid email address.
            </ng-container>
          </ng-template>
        </app-control-errors>
      </div>
    </div>

    <div class="field">
      <label>
        <div class="field__name">Password</div>
        <input class="field__control" type="password" formControlName="password" data-testid="password" />
      </label>

      <div class="field__info">
        <p class="field__description">
          Should contain at least 1 lower and 1 uppercase letters, minimum 8 characters long. Can not contain user's
          first or last name.
        </p>

        <app-control-errors controlName="password">
          <ng-template let-errors>
            <ng-container *ngIf="errors.required">
              Password must be given.
            </ng-container>
            <ng-container *ngIf="errors.pattern">
              Password must contain lower and uppercase letters.
            </ng-container>
            <ng-container *ngIf="errors.minlength">
              Password must have a minimum of 8 characters.
            </ng-container>
            <ng-container *ngIf="errors.includesName">
              Password must not contain user's first or last name.
            </ng-container>
          </ng-template>
        </app-control-errors>
      </div>
    </div>

    <button class="btn signup__submit" data-testid="submit">Submit</button>
  </form>
</div>
